(*------------------------------------------------------------------*)
(*                      HINTDEMO.PAS                                *)
(*        Zeichnen im Vorder- und Hintergrund mit den               *)
(*            Grafikprimitiven aus IGRAFIK.PAS                      *)
(*     (C) Prof. Dr. Rudolf Borges & PASCAL INTERNATIONAL           *)

PROGRAM HintDemo;

TYPE x_Koord_Sys = INTEGER;
     y_Koord_Sys = INTEGER;

VAR y1, y2: INTEGER;

(*$I IGRAFIK *)
(*$I IMEMMEM *)
(* Fuer Kompilierung zum COM-File *)
(* ersetze IMEMMEM durch ICOMFILE *)

BEGIN
  (* Nur fuer Kompilierung zum COM-File mit *)
  (* voreingestellter Startadresse:         *)
  HeapZeigerSetzen;
  ClrScr; GotoXY(10,13);
  Write('Der erste Teil des Bildes wird im Hintergrund gezeichnet.');
  SystemSicherstellen;
  y1 := ScreenYmax DIV 2;
  FOR y2 := 0 TO ScreenYmax DIV 10 DO BEGIN
    Position(0, y1);
    PlotLine(ScreenXmax, 10 * y2);
  END;
  GrafikEin; Delay(3000); Exit_Graphic;
  GotoXY(10,13);
  Write('Der zweite Teil des Bildes wird im Vordergrund gezeichnet.');
  Delay(3000); ClrScr; GrafikEin;
  y2 := y1;
  FOR y1 := 0 TO ScreenYmax DIV 10 DO BEGIN
    Position(0, 10 * y1);
    PlotLine(ScreenXmax, y2);
  END;
  REPEAT UNTIL KeyPressed;
  SystemZurueckbringen;
  GotoXY(20,13); WriteLn('Aufwiedersehen!');
END.
