(*------------------------------------------------------------------*)
(*                       IMEMMEM.PAS                                *)
(* Fuer die Kompilierung der Apple-Grafik im Memory-Modus bei Aus-  *)
(* lagerung des Systems im Memory.                                  *)
(*        (C) Prof. Dr. Rudolf Borges & PASCAL INTERNATIONAL        *)

VAR Lager: ARRAY(.$3000..$4FFF.) OF BYTE;


PROCEDURE SystemSicherstellen;
BEGIN
  InitErrorCheck;
  Move(Mem(.$3000.), Lager, $2000);
  GrafikLoeschen;
END;


PROCEDURE SystemZurueckbringen;
BEGIN
  IF Grafik THEN Exit_Graphic;
  Move(Lager, Mem(.$3000.), $2000);
  OldErrorCheck;
END;
