{*********************************************************}
{*                     DOLINE.PAS                        *}
{*   ein Demonstrationsprogramm der Integer DDA do_line  *}
{*       (C) Heinz Hagemeyer & PASCAL INTERNATIONAL      *}

PROGRAM do_line_demo;

{$I PLOGRAPH.INC Einbinden des Plotter-Graphik-Modul's    }

{*********************************************************}
{* Das File PLOGRAPH.INC enthaellt u.a. die Proceduren   *}
{*                                                       *}
{*       procedure punkt(x,y : integer);                 *}
{*       begin                                           *}
{*               ...      (* Sharp MZ 800 - spezifisch *)*}
{*       end;                                            *}
{*                                                       *}
{*       procedure status;(* Sharp MZ 800 - spezifisch *)*}
{*       begin                                           *}
{*               ...                                     *}
{*       end;                                            *}
{*                                                       *}
{*       und die Systemvariable                          *}
{*                                                       *}
{*       var geraet;            ( siehe Begleittext !)   *}
{*                                                       *}

{$I DOLINE.INC }

VAR x,y,x1,y1 : INTEGER;

BEGIN
  geraet := bildschirm;  
  { Dieser Befehl muss bei anderen Graphik - Systemen }
  { entfernt bzw. durch INIT_GRAPHIK oder aehnl.      }
  { ersetzt werden.                                   }

  ClrScr;   { loescht den Bildschirm }

  FOR x := 0 TO 19 DO BEGIN
    x1 := x SHL 5;    { schnelles Mult. mit 32  }
    do_line(x1,0,640-x1,200);
  END;

  FOR y := 15 DOWNTO 0 DO BEGIN
    y1 := y SHL 4;    {  schnelles Mult. mit 16  }
    do_line(0,y1,640,200-y1);
  END;

END.
