MODULE PROBE;

FROM InOut IMPORT WriteString,WriteLn,ReadInt,Read,Write,
                  EOL;
FROM PATRICIA IMPORT search,insertelement,deleteelement,
                     tree,initialise,key;

VAR
    exit        : BOOLEAN;
    eingabe1    : INTEGER;
    flag        : BOOLEAN;
    c           : key;
    baum1       : tree;

(*********************************************************)
(* liest eine Buchstabenkette von max. 20 Zeichen in ein *)
(*                       Array ein                       *)
(*********************************************************)

PROCEDURE ReadKey;

VAR
    n : INTEGER;
    a : CHAR;

BEGIN
    Read (a);
    Write (a);
    n := 0;
    WHILE a <> EOL DO
        c[n] := a;
        n := n + 1;
        Read (a);
        Write (a);
    END;
    IF n < 20 THEN
        c[n] := 0C;
    END;
END ReadKey;

BEGIN
  exit := FALSE;
  REPEAT
    WriteLn;
    WriteString ('Bitte whlen Sie aus dem Men aus: ');
    WriteLn;
    WriteString ('1  Initialisieren des Baumes ');
    WriteLn;
    WriteString ('2  Einfgen eines neuen Elementes ');
    WriteLn;
    WriteString ('3  Lschen eines Elementes ');
    WriteLn;
    WriteString ('4  Suchen eines Elementes ');
    WriteLn;
    WriteString ('5  Programmende ');
    WriteLn;
    WriteString ('Ihre Wahl: ');
    ReadInt (eingabe1);
    WriteLn;
    CASE eingabe1 OF
       1 : initialise (baum1)
     | 2 : WriteString ('Einzufgendes Element: ');
           ReadKey;
           WriteLn;
           insertelement (baum1,c)
     | 3 : WriteString ('Zu lschendes Element: ');
           ReadKey;
           deleteelement (baum1,c)
     | 4 : WriteString ('Zu suchendes Element: ');
           ReadKey;
           flag := search (baum1,c);
           WriteString ('Der Schlssel "');
           WriteString (c);
           WriteString ('" ist im Baum ');
           IF (NOT flag) THEN
              WriteString ('nicht ');
           END;
           WriteString ('enthalten!')
     | 5 : exit := TRUE;
     ELSE
           WriteString ('Fehler in der Eingabe!');
           WriteLn;
    END; (* CASE *)
  UNTIL exit
END PROBE.
