/*-------------- SUBST.PRO ------------------*/
/*     Integration mit Substitution in       */
/*            Standard Prolog                */
/*            (C) R.Hring                   */

int(Term,X,E) :-
  subterm(Sub,Term),  /* Sub-Term erzeugen   */
  X\=Sub, Term\=Sub,  /* Sinnlose Terme weg  */
  not(const(Sub,X)),  /* Sub mu X enthalten */
  dif(Sub,X,D1),      /* Sub differenzieren  */
  Neu:== Term/D1,     /* Neuen Integrand     */
  int(Neu,Sub,E).     /* Nach Sub integ.     */

