(* ----------------------------------------------------- *)
(*                       BEGININT.INC                    *)
(*   Inline-Anweisung zum Beginn der Interrupt-Routine   *)
(* ----------------------------------------------------- *)
TYPE
  PgmRegs_=
     RECORD CASE Integer OF
       1: (PgmDs,PgmEs,PgmSi,PgmDi,PgmDx,PgmCx,PgmBx,PgmAx,
           PgmSp,PgmBp,PgmIp,PgmCs,PgmFlags     : INTEGER);
       2: (PgmDsAlt,PgmEsAlt,PgmSiAlt,PgmDiAlt  : Integer;
           PgmDl,PgmDh,PgmCl,PgmCh,PgmBl,PgmBh,
           PgmAl,PgmAh                          : Byte);
     END;
VAR
  Dummy   : ARRAY [0..15] OF BYTE;
  PgmRegs : PgmRegs_  ABSOLUTE Dummy;
BEGIN
  Inline ($FB/$83/$C4/$10/$50/$53/$51/$52/$57/$56/$06/$1E/
          $2E/$A1/$A0/$00/$50/$1F);
(* ----------------------------------------------------- *)
(*                  Ende von BEGININT.INC                *)