/*--------------------------------------------------------*/
/*                      HERCDEMO.PRO                      */
/*       Hercules-Grafik mit Turbo Prolog genutzt         */
/*          Linken von Turbo Prolog mit Turbo C           */
/*        (C) M.Schlter & PASCAL INTERNATIONAL           */

project "HERCDEMO"

global predicates
  cpinit - language c
  cls - language c
  hires - language c
  textmode - language c
  Plot(integer,integer,integer) - (i,i,i) language c
  XOrMode(integer) - (i) language c
  TextPixel(integer,integer,integer) - (i,i,o) language c
  Draw(integer,integer,integer,integer,integer) - 
    (i,i,i,i,i)  language c
  Circle(integer,integer,integer,integer) - (i,i,i,i) language c

predicates 
  linien
  linien1(integer,integer,integer,integer,integer,integer)
  test
  
clauses
  linien :-
    linien1(0,175,719,0,10,347),
    linien1(719,175,0,0,10,347).
  
  linien1(_,_,_,AktY,_,Ende) :-
    AktY > Ende, !.
  linien1(StartX,StartY,EndX,EndY,Incr,Ende) :-
    !,
    Draw(StartX,StartY,EndX,EndY,1),
    NEndY = EndY + Incr,
    linien1(StartX,StartY,EndX,NEndY,Incr,Ende).
  
  test :-
    cpinit,
    hires,
    cls,
    linien,
    readchar(_),
    cls,
    textmode.
goal test.