
module hanoi.

/*$eject*/
body.

start(N) :- 
     write("Tuerme von Hanoi mit 9 Scheiben."), nl, write(N), 
       write(" Wiederholungen, OHNE I/O ! "), nl, 
       write("Start..."), nl, n_hanoi(0,N), write("...Ende !"), 
       nl .

n_hanoi(ENDE,ENDE) .
n_hanoi(N,ENDE) :- 
     hanoi(9), N1 is N+1, n_hanoi(N1,ENDE) .

hanoi(N) :- 
     scheibe(N,linken,rechten,mittleren) .

scheibe(0,_,_,_) .
scheibe(X,VON,NACH,UEBER) :- 
     M is X-1, scheibe(M,VON,UEBER,NACH), 
       scheibe(M,UEBER,NACH,VON) .

lege(A,B) :- 
     write("Lege Scheibe vom "), write(A), write(" zum "), 
       write(B), write(" Stift."), nl .

:- hanoi(4).
endmod /* hanoi */  .
