"Beispielprogramm 4 - W. Kreitmair"
"Automatische Sprachanalyse mit PROLOG II"

SATZ(<x,y>, satz(n-p,v-p)) -> 
                  NP(<x,x1>, n-p,<n-um,g-en,nomin>)    
                  VP(<x1,y>, v-p,<n-um>);

NP(<x,y>, np(s),<n-um,g-en,k-as>) -> 
                  EIGENNAME(<x,y>, s,<n-um,g-en,k-as>);
NP(<x,y>, np(a-dj,n-om),<n-um,g-en,k-as>) -> 
                  ADJEKTIV(<x,x1>, a-dj,<attrib,n-um,g-en,k-as>)   
                  NOMEN(<x1,y>, n-om,<n-um,g-en,k-as>);
NP(<x,y>, np(a-rt,a-dj,n-om),<n-um,g-en,k-as>) -> 
                  ARTIKEL(<x,x1>, a-rt,<n-um,g-en,k-as>)  
                  ADJEKTIV(<x,x2>, a-dj,<attrib,n-um,g-en,k-as>)  
                  NOMEN(<x2,y>, n-om,<n-um,g-en,k-as>);
NP(<x,y>, np(a-rt,n-om,r-el-satz),<n-um,g-en,k-as>) ->
                   ARTIKEL(<x,x1>, a-rt,<n-um,g-en,k-as>)  
                  NOMEN(<x1,x2>, n-om,<n-um,g-en,k-as>)  
                  RELATIVSATZ(<x2,y>, r-el-satz,<n-um>);

VP(<x,y>, vp(s),<n-um>) -> 
                  VERB(<x,y>, s,<intrans,n-um>);
VP(<x,y>, vp(k-op,a-dj),<n-um>) -> 
                  KOPULA(<x,x1>,k-op,<n-um>)  
                  ADJEKTIV(<x1,y>, a-dj,<praedik,n-um,g-en,k-as>);
VP(<x,y>, vp(v-erb,n-p),<n-um>) -> 
                  VERB(<x,x1>, v-erb,<trans,n-um>)  
                  NP(<x1,y>, n-p,<n-um,g-en,akk>);

VP'(<x,y>, vp'(a-dj,k-op),<n-um>) -> 
                  ADJEKTIV(<x,x1>, a-dj,<praedik,n-um,g-en,k-as>)  
                  KOPULA(<x1,y>, k-op,<n-um>);
VP'(<x,y>, vp'(v-erb),<n-um>) -> 
                  VERB(<x,y>, v-erb,<intrans,n-um>); 
VP'(<x,y>, vp'(v-erb,n-p),<n-um>) ->  
                  NP(<x,x1>, n-p,<n-um,g-en,akk>) 
                  VERB(<x1,y>, v-erb,<trans,n-um>);

RELATIVSATZ(<x,x>, leer,<n-um>) -> ;
RELATIVSATZ(<x,y>, rel-satz(r-elPro,v-p),<n-um>) -> 
                  RELATIV-PRONOMEN(<x,x1>, r-elPro,<n-um,g-en,nomin>)  
                  VP'(<x1,y>, v-p,<n-um>);

ARTIKEL(<x,y>, s,<n-um,g-en,k-as>) -> 
                  UNBEST-ARTIKEL(<x,y>, s,<n-um,g-en,k-as>);
ARTIKEL(<x,y>, s,<n-um,g-en,k-as>) -> 
                  BEST-ARTIKEL(<x,y>, s,<n-um,g-en,k-as>);

VERB(<schlaeft.x,x>, verb(schlafen),<intrans,n-um>) ->;
VERB(<kuesst.x,x>, verb(kuessen),<v-al,n-um>) ->;
VERB(<kuessen.x,x>, verb(kuessen),<v-al,n-um>) ->;
VERB(<liebt.x,x>, verb(lieben),<trans,n-um>) ->;
VERB(<heiratet.x,x>, verb(heiraten),<trans,n-um>) ->;

KOPULA(<ist.x,x>, kop(ist),<sg>) ->;
KOPULA(<sind.x,x>, kop(sind),<pl>) ->;

NOMEN(<Mann.x,x>, nom(Mann),<sg,mask,k-as>) ->;
NOMEN(<Liebhaber.x,x>, nom(Liebhaber),<n-um,mask,k-as>) ->;
NOMEN(<Ehefrau.x,x>, nom(Ehefrau),<sg,fem,k-as>) ->;
NOMEN(<Ehefrauen.x,x>, nom(Ehefrau),<pl,fem,k-as>) ->;
NOMEN(<Freundin.x,x>, nom(Freundin),<sg,fem,k-as>) ->;

EIGENNAME(<Helmut.x,x>, en(Helmut),<sg,mask,k-as>) ->;
EIGENNAME(<Rita.x,x>, en(Rita),<sg,fem,k-as>) ->;

RELATIV-PRONOMEN(<der.x,x>, rel-pro(der),<sg,mask,k-as>) ->;
RELATIV-PRONOMEN(<die.x,x>, rel-pro(die),<pl,g-en,k-as>) ->;
RELATIV-PRONOMEN(<die.x,x>, rel-pro(die),<sg,fem,k-as>) ->;

ADJEKTIV(<jung.x,x>, adj(jung),<praedik,n-um,g-en,k-as>) ->;
ADJEKTIV(<junge.x,x>, adj(junge),<attrib,n-um,g-en,nomin>) ->;
ADJEKTIV(<junge.x,x>, adj(junge),<attrib,n-um,fem,akk>) ->;
ADJEKTIV(<junge.x,x>, adj(junge),<attrib,pl,mask,akk>) ->;
ADJEKTIV(<jungen.x,x>, adj(jungen),<attrib,sg,mask,akk>) ->;
ADJEKTIV(<feurig.x,x>, adj(feurig,<praedik,n-um,g-en,k-as>)) ->;
ADJEKTIV(<feurige.x,x>, adj(feurige),<attrib,n-um,g-en,nomin>) ->;
ADJEKTIV(<feurige.x,x>, adj(feurige),<attrib,n-um,fem,akk>) ->;
ADJEKTIV(<feurige.x,x>, adj(feurige),<attrib,pl,mask,akk>) ->;
ADJEKTIV(<feurigen.x,x>, adj(feurige),<attrib,sg,mask,akk>) ->;
ADJEKTIV(<betrogene.x,x>, adj(betrogene),<attrib,n-um,g-en,nomin>) ->;

UNBEST-ARTIKEL(<ein.x,x>, unbest-art(ein),<sg,mask,nomin>) ->;
UNBEST-ARTIKEL(<eine.x,x>, unbest-art(eine),<sg,fem,nomin>) ->;

BEST-ARTIKEL(<der.x,x>, best-art(der),<sg,mask,nomin>) ->;
BEST-ARTIKEL(<die.x,x>, best-art(die),<n-um,fem,k-as>) ->;
BEST-ARTIKEL(<den.x,x>, best-art(den),<sg,mask,akk>) ->;
BEST-ARTIKEL(<den.x,x>, best-art(den),<pl,g-en,akk>) ->;

>) ->;
BEST-ARTIKEL(<den.x,x>, best-art(den),<sg,mask,akk>) ->;
BEST-ARTIKE