(*------------------------------------------------------------------*)
(*                        IMEMDISK.PAS                              *)
(* Fuer die Kompilierung der Apple-Grafik im Memory-Modus bei Aus-  *)
(* lagerung des Systems auf Diskette.                               *)
(*       (C) Prof. Dr. Rudolf Borges & PASCAL INTERNATIONAL         *)

VAR FilVar: FILE;
    Screen: ARRAY(.$3000..$4FFF.) OF BYTE ABSOLUTE $3000;


PROCEDURE SystemSicherstellen;
BEGIN
  InitErrorCheck;
  Assign(FilVar, 'DEditor.Dta');
  ReWrite(FilVar);
  BlockWrite(FilVar, Screen, 64);
  Close(FilVar);
  GrafikLoeschen;
END;


PROCEDURE SystemZurueckbringen;
BEGIN
  IF Grafik THEN Exit_Graphic;
  Assign(FilVar, 'DEditor.Dta');
  ReSet(FilVar);
  BlockRead(FilVar, Screen, 64);
  Close(FilVar);
  OldErrorCheck;
END;
