;----------------------- ANALOG.ASM -----------------------
;       Abfrage eines Game Adapters unter BCI Pascal
;           Function Analog (Maske) : integer
;---------------------- 1987 by M.A. ----------------------
public analog
code segment byte public 'PASCAL'   ; ... Gre an BCI ...
assume cs:code

analog proc far                     ; Abfrage Analogeingang
       pop bx
       push cs
       push bx                      ; hier geht's zurck
       mov si,sp
       mov bx,[si+4]                ; hole Maske
       mov dx,0201h                 ; Portadresse
       mov cx,0000h                 ; unser Zhler
       mov ah,00h
       out dx,al                    ; starte Messung
loop:  in al,dx                     ; Wert einlesen
       and al,0fh                   ; Buttons ausblenden
       test al,bl                   ; schon fertig?
       jp exit1
       inc cx                       ; Zhler erhhen
       cmp cx,1fffh                 ; kleine Notbremse
       jne loop
exit1: mov ax,cx                    ; Ergebnis bergeben
       or ax,ax                     ; Flags subern
       ret 2                        ; Stack subern
analog endp                         ; und fertig...

code ends
end
;---------------------- Ende ANALOG.ASM -------------------
