/*-------------- DETERM1.PRO -----------------*/
/*    Test der "rekursiven Iteration"         */
/*           (C) Stefan Musche                */

predicates
  iteration(integer) 
  dummy(real)  /* Fr's Backtracking */

clauses
  dummy(3.3). /* Dummy-Datenbasis fr */
  dummy(4.4). /* Backtracking.        */

  iteration(0).   /* Ende, wenn Zhler = 0 */
  iteration(N) :-
    dummy(_),    /* Stack-Optimierung verhindern */
    storage(St,_,_), /* Stackplatz ermitteln */
    write(N,"te Iteration, Stackplatz = ",St),
    nl,
    Next_N = N - 1,
    !,  /* Cut, damit Stack geleert wird, */
    iteration(Next_N).   /* sonst berlauf */
 
 GOAL
   iteration(32000).
   
    
  
  
  