/*--------------------------------------------------------*/
/*                      MIX-LANG.PRO                      */
/*    Demonstration von "mixed language programming"      */
/*             mit Turbo Prolog und Turbo C               */
/*        (C) M.Schlter & PASCAL INTERNATIONAL           */

project "MIX-LANG"

global predicates
  cpinit - language c
  save_screen(string,integer) - (i,o) language c
  load_screen(string,integer) - (i,o) language c

predicates 
  linien
  linien1(integer,integer,integer,integer,integer,integer)
  test
  
clauses
  linien :-
    linien1(0,16000,31999,0,1000,31999),
    linien1(31999,16000,0,0,1000,31999).
  
  linien1(_,_,_,AktY,_,Ende) :-
    AktY > Ende, !.
  linien1(StartX,StartY,EndX,EndY,Incr,Ende) :-
    !,
    line(StartY,StartX,EndY,EndX,1),
    NEndY = EndY + Incr,
    linien1(StartX,StartY,EndX,NEndY,Incr,Ende).
  
  test :-
    cpinit,
    graphics(2,1,0),
    linien,
    save_screen("bild.dat",Fehler1),
    readchar(_),
    graphics(2,1,0),
    readchar(_),
    load_screen("bild.dat",Fehler2),
    readchar(_),
    text,
    write("Fehler 1 = ",Fehler1),nl,
    write("Fehler 2 = ",Fehler2).
    
goal test.