(* ----------------------------------------------------------------------- *)
(*                             OLDSTACK.INC                                *)
(*  Schaltet wieder zurck  auf  den ursprnglichen  (vom unterbrochenen   *)
(*  Programm) benutzten Laufzeitstapel. Falls NEWSTACK in der Interrupt-   *)
(*  Routine ausgefhrt wurde  (und nur dann!),  mu dieses Inline-State-   *)
(*  ment unbedingt vor Ausgang aus der Prozedur mittels EXITINT oder BE-   *)
(*  GININT erfolgen!                                                       *)
(* ----------------------------------------------------------------------- *)
INLINE ($89/$EC/       (*  MOV    SP,BP         ;SP richtig positionieren  *)
        $5D/           (*  POP    BP            ;alten Basepointer holen   *)
        $59/           (*  POP    CX            ;alten Stackpointer holen  *)
        $5B/           (*  POP    BX            ;altes Stacksegment holen  *)
        $89/$CC/       (*  MOV    SP,CX         ;und die alten Stapelwerte *)
        $8E/$D3);      (*  MOV    SS,BX         ;...wiederherstellen       *)
(* ----------------------------------------------------------------------- *)
(*                             OLDSTACK.INC                                *)
