'* ------------------------------------------------------- *
'*                  MOUSESUB.BAS                           *
'*        Routinen fr Microsoft-kompatible Muse          *
'* ------------------------------------------------------- *
'*   (c) 1988 by HEIMSOETH Software /Technical Support     *
'*          verffentlicht in TOOLBOX 10/11'88	           *
'* ------------------------------------------------------- *
'*            Compiler: Turbo Basic  V1.01e                *
'* ------------------------------------------------------- *
%TRUE  = -1
%FALSE = 0

SUB InitMouse
  REG 1,0
  CALL INTERRRUPT 51
END SUB

SUB ShowCursor
  REG 1,1
  CALL INTERRUPT 51
END SUB

SUB HideCursor
  REG 1,2
  CALL INTERRUPT 51
END SUB

DEF FN XPosition
  REG 1,3
  CALL INTERRUPT 51
  FN XPosition = REG(3)
END DEF

DEF FN YPosition
  REG 1,3
  CALL INTERRUPT 51
  FN YPosition = REG(4)
END DEF

DEF FN LeftButton
  REG 1,3
  CALL INTERRUPT 51
  IF ((REG(2) AND 1) = 1) THEN
    FN LeftButton = %TRUE
  ELSE
    FN LeftButton = %FALSE
  END IF
END DEF

DEF FN RightButton
  REG 1,3
  CALL INTERRUPT 51
  IF ((REG(2) AND 2) = 2 THEN
    FN RightButton = %TRUE
  ELSE
    FN RightButton = %FALSE
  END IF
END DEF

SUB SetXY(x%,y%)
  REG 1,4
  REG 3,x%
  REG 4,y%
  CALL INTERRUPT 51
END SUB

SUB SetXRange(x1%,x2%)
  REG 1,7
  REG 2,0
  REG 3,x1%
  REG 4,x2%
  CALL INTERRUPT 51
END SUB

SUB SetYRange(y1%,y2%)
  REG 1,8
  REG 2,0
  REG 3,y1%
  REG 4,y2%
  CALL INTERRUPT 51
END SUB
'* ------------------------------------------------------- *
'*               Ende von MOUSESUB.BAS                     *